Loading...
Searching...
No Matches
gtsam::HybridNonlinearFactorGraph Class Reference

## Detailed Description

## Nonlinear Hybrid Factor Graph

This is the non-linear version of a hybrid factor graph. Everything inside needs to be hybrid factor or hybrid conditional.

Inheritance diagram for gtsam::HybridNonlinearFactorGraph:

## Public Member Functions

Constructors
template<class DERIVEDFACTOR>
| HybridNonlinearFactorGraph (const FactorGraph< DERIVEDFACTOR > &graph)
| Implicit copy/downcast constructor to override explicit template container constructor.
void | print (const std::string &s="HybridNonlinearFactorGraph", const KeyFormatter &keyFormatter=DefaultKeyFormatter) const override
| Print the factor graph.
Standard Interface
boost::shared_ptr< HybridGaussianFactorGraph > | linearize (const Values Values &continuousValues) const
| Linearize all the continuous factors in the HybridNonlinearFactorGraph.
Public Member Functions inherited from gtsam::HybridFactorGraph
| HybridFactorGraph ()=default
| Default constructor.
template<class DERIVEDFACTOR>
| HybridFactorGraph (const FactorGraph< DERIVEDFACTOR > &graph)
| Implicit copy/downcast constructor to override explicit template container constructor.
std::set< DiscreteKey > | discreteKeys () const
| Get all the discrete keys in the factor graph.
KeySet | discreteKeySet () const
| Get all the discrete keys in the factor graph, as a set.
std::unordered_map< Key, DiscreteKey > | discreteKeyMap () const
| Get a map from Key to corresponding DiscreteKey.
const KeySet | continuousKeySet () const
| Get all the continuous keys in the factor graph.
Public Member Functions inherited from gtsam::FactorGraph< Factor >
virtual | ~FactorGraph ()=default
| Default destructor Public and virtual so boost serialization can call it.
| FactorGraph (std::initializer_list< boost::shared_ptr< DERIVEDFACTOR > > sharedFactors)
| Constructor that takes an initializer list of shared pointers.
void | reserve (size_t size)
| Reserve space for the specified number of factors if you know in advance how many there will be (works like FastVector::reserve).
IsDerived< DERIVEDFACTOR > | push_back (boost::shared_ptr< DERIVEDFACTOR > factor)
| Add a factor directly using a shared_ptr.
IsDerived< DERIVEDFACTOR > | emplace_shared (Args &&... args)
| Emplace a shared pointer to factor of given type.
IsDerived< DERIVEDFACTOR > | push_back (const DERIVEDFACTOR &factor)
| Add a factor by value, will be copy-constructed (use push_back with a shared_ptr to avoid the copy).
IsDerived< DERIVEDFACTOR > | add (boost::shared_ptr< DERIVEDFACTOR > factor)
| add is a synonym for push_back.
std::enable_if< std::is_base_of< FactorType, DERIVEDFACTOR >::value, boost::assign::list_inserter< RefCallPushBack< This > > >::type | operator+= (boost::shared_ptr< DERIVEDFACTOR > factor)
| += works well with boost::assign list inserter.
HasDerivedElementType< ITERATOR > | push_back (ITERATOR firstFactor, ITERATOR lastFactor)
| Push back many factors with an iterator over shared_ptr (factors are not copied).
HasDerivedValueType< ITERATOR > | push_back (ITERATOR firstFactor, ITERATOR lastFactor)
| Push back many factors with an iterator (factors are copied).
HasDerivedElementType< CONTAINER > | push_back (const CONTAINER &container)
| Push back many factors as shared_ptr's in a container (factors are not copied).
HasDerivedValueType< CONTAINER > | push_back (const CONTAINER &container)
| Push back non-pointer objects in a container (factors are copied).
void | add (const FACTOR_OR_CONTAINER &factorOrContainer)
| Add a factor or container of factors, including STL collections, BayesTrees, etc.
boost::assign::list_inserter< CRefCallPushBack< This > > | operator+= (const FACTOR_OR_CONTAINER &factorOrContainer)
| Add a factor or container of factors, including STL collections, BayesTrees, etc.
std::enable_if< std::is_base_of< This, typenameCLIQUE::FactorGraphType >::value >::type | push_back (const BayesTree< CLIQUE > &bayesTree)
| Push back a BayesTree as a collection of factors.
FactorIndices | add_factors (const CONTAINER &factors, bool useEmptySlots=false)
| Add new factors to a factor graph and returns a list of new factor indices, optionally finding and reusing empty factor slots.
bool | equals (const This &fg, double tol=1e-9) const
| Check equality up to tolerance.
size_t | size () const
| return the number of factors (including any null factors set by remove() ).
bool | empty () const
| Check if the graph is empty (null factors set by remove() will cause this to return false).
const sharedFactor | at (size_t i) const
| Get a specific factor by index (this checks array bounds and may throw an exception, as opposed to operator[] which does not).
sharedFactor & | at (size_t i)
| Get a specific factor by index (this checks array bounds and may throw an exception, as opposed to operator[] which does not).
const sharedFactor | operator[] (size_t i) const
| Get a specific factor by index (this does not check array bounds, as opposed to at() which does).
sharedFactor & | operator[] (size_t i)
| Get a specific factor by index (this does not check array bounds, as opposed to at() which does).
const_iterator | begin () const
| Iterator to beginning of factors.
const_iterator | end () const
| Iterator to end of factors.
sharedFactor | front () const
| Get the first factor.
sharedFactor | back () const
| Get the last factor.
double | error (const HybridValues &values) const
| Add error for all factors.
iterator | begin ()
| non-const STL-style begin()
iterator | end ()
| non-const STL-style end()
virtual void | resize (size_t size)
| Directly resize the number of factors in the graph.
void | remove (size_t i)
| delete factor without re-arranging indexes by inserting a nullptr pointer
void | replace (size_t index, sharedFactor factor)
| replace a factor by index
iterator | erase (iterator item)
| Erase factor and rearrange other factors to take up the empty space.
iterator | erase (iterator first, iterator last)
| Erase factors and rearrange other factors to take up the empty space.
void | dot (std::ostream &os, const KeyFormatter &keyFormatter=DefaultKeyFormatter, const DotWriter &writer=DotWriter()) const
| Output to graphviz format, stream version.
std::string | dot (const KeyFormatter &keyFormatter=DefaultKeyFormatter, const DotWriter &writer=DotWriter()) const
| Output to graphviz format string.
void | saveGraph (const std::string &filename, const KeyFormatter &keyFormatter=DefaultKeyFormatter, const DotWriter &writer=DotWriter()) const
| output to file with graphviz format.
size_t | nrFactors () const
| return the number of non-null factors
KeySet | keys () const
| Potentially slow function to return all keys involved, sorted, as a set.
KeyVector | keyVector () const
| Potentially slow function to return all keys involved, sorted, as a vector.
bool | exists (size_t idx) const
| MATLAB interface utility: Checks whether a factor index idx exists in the graph and is a live pointer.

## Public Types

using | Base = HybridFactorGraph
using | This = HybridNonlinearFactorGraph
| this class
using | shared_ptr = boost::shared_ptr<This>
| shared_ptr to This
using | Values = gtsam::Values
| backwards compatibility
using | Indices = KeyVector
Public Types inherited from gtsam::HybridFactorGraph
using | Base = FactorGraph<Factor>
using | This = HybridFactorGraph
| this class
using | shared_ptr = boost::shared_ptr<This>
| shared_ptr to This
using | Values = gtsam::Values
| backwards compatibility
using | Indices = KeyVector
Public Types inherited from gtsam::FactorGraph< Factor >
typedef Factor | FactorType
| factor type
typedef boost::shared_ptr< Factor > | sharedFactor
| Shared pointer to a factor.
typedef sharedFactor | value_type
typedef FastVector< sharedFactor >::iterator | iterator
typedef FastVector< sharedFactor >::const_iterator | const_iterator

## Additional Inherited Members

Protected Member Functions inherited from gtsam::FactorGraph< Factor >
bool | isEqual (const FactorGraph &other) const
| Check exact equality of the factor pointers. Useful for derived ==.
| FactorGraph ()
| Default constructor.
| FactorGraph (ITERATOR firstFactor, ITERATOR lastFactor)
| Constructor from iterator over factors (shared_ptr or plain objects).
| FactorGraph (const CONTAINER &factors)
| Construct from container of factors (shared_ptr or plain objects).
Protected Attributes inherited from gtsam::FactorGraph< Factor >
FastVector< sharedFactor > | factors_
| concept check, makes sure FACTOR defines print and equals

## Constructor & Destructor Documentation

## HybridNonlinearFactorGraph()

template<class DERIVEDFACTOR>

gtsam::HybridNonlinearFactorGraph::HybridNonlinearFactorGraph | ( | const FactorGraph< DERIVEDFACTOR > & | graph | ) |

inline

Implicit copy/downcast constructor to override explicit template container constructor.

In BayesTree this is used for: cachedSeparatorMarginal_.reset(*separatorMarginal)

## Member Function Documentation

## linearize()

HybridGaussianFactorGraph::shared_ptr gtsam::HybridNonlinearFactorGraph::linearize | ( | const Values Values & | continuousValues | ) | const

Linearize all the continuous factors in the HybridNonlinearFactorGraph.

Parameters

  continuousValues | Dictionary of continuous values.

Returns
  HybridGaussianFactorGraph::shared_ptr

## print()

void gtsam::HybridNonlinearFactorGraph::print | ( | const std::string & | s = "HybridNonlinearFactorGraph",
|  | const KeyFormatter & | keyFormatter = DefaultKeyFormatter ) const

override virtual

Print the factor graph.

Reimplemented from gtsam::FactorGraph< Factor >.

The documentation for this class was generated from the following files:

- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/hybrid/HybridNonlinearFactorGraph.h
- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/hybrid/HybridNonlinearFactorGraph.cpp